--- old/usr/src/lib/libfakekernel/common/kmem.c	Mon Nov  6 02:54:35 2017
+++ new/usr/src/lib/libfakekernel/common/kmem.c	Mon Nov  6 02:54:35 2017
@@ -11,6 +11,7 @@
 
 /*
  * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2017 RackTop Systems.
  */
 
 #include <sys/kmem.h>
@@ -18,6 +19,7 @@
 #include <sys/debug.h>
 #include <sys/ksynch.h>
 #include <sys/systm.h>
+#include <sys/cmn_err.h>
 
 #include <umem.h>
 
@@ -65,7 +67,30 @@
 	return (umem_zalloc(size, kmem2umem_flags(kmflags)));
 }
 
+/*
+ * Do not change the length of the returned string; it must be freed
+ * with strfree().
+ */
+char *
+kmem_asprintf(const char *fmt, ...)
+{
+	int size;
+	va_list adx;
+	char *buf;
 
+	va_start(adx, fmt);
+	size = vsnprintf(NULL, 0, fmt, adx) + 1;
+	va_end(adx);
+
+	buf = kmem_alloc(size, KM_SLEEP);
+
+	va_start(adx, fmt);
+	size = vsnprintf(buf, size, fmt, adx);
+	va_end(adx);
+
+	return (buf);
+}
+
 void
 kmem_free(void *buf, size_t size)
 {
